<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="pl" xml:lang="pl">

<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<meta http-equiv="reply-to" content="mail" />
<meta http-equiv="pragma" content="no-cache" />
<meta name="author" content="mynthon" />
<meta name="copyright" content="mynthon" />
<meta name="keywords" content="keyword1, keyword2" />
<meta name="description" content="Script helps to find right encoding for filenames returned by readdir() php function." />
<meta name="generator" content="Snape v1.2 b1 - SciTEFlash" />
<title>readdir() encoding problem / readdir problem z kodowaniem znaków</title>

</head>


<body lang="pl" dir="ltr">
<h1>readdir() encoding problem / problem z kodowaniem</h1>
<?php

function checkCharset($testString){

	$out = array();
	array_push($out, $testString);
	$encoding=array("ASCII",
	"ISO-8859-1","ISO-8859-2","ISO-8859-3","ISO-8859-4","ISO-8859-5","ISO-8859-7","ISO-8859-9","ISO-8859-10","ISO-8859-13","ISO-8859-14","ISO-8859-15","ISO-8859-16","KOI8-R","KOI8-U","KOI8-RU","CP1250","CP1251","CP1252","CP1253","CP1254","CP1257","CP850","CP866","Mac Roman","Mac CentralEurope","Mac Iceland","Mac Croatian","Mac Romania","Mac Cyrillic","Mac Ukraine","Mac Greek","Mac Turkish", "Macintosh","ISO-8859-6","ISO-8859-8", "CP1255","CP1256", "CP862","Mac Hebrew","Mac Arabic","EUC-JP", "SHIFT_JIS", "CP932", "ISO-2022-JP", "ISO-2022-JP-2", "ISO-2022-JP-1","EUC-CN", "HZ", "GBK", "GB18030", "EUC-TW", "BIG5", "CP950", "BIG5-HKSCS", "ISO-2022-CN", "ISO-2022-CN-EXT","EUC-KR","CP949","ISO-2022-KR","JOHAB","ARMSCII-8","Georgian-Academy","Georgian-PS","KOI8-T","TIS-620","CP874","MacThai","MuleLao-1","CP1133","VISCII","TCVN","CP1258","HP-ROMAN8","NEXTSTEP","UTF-8","UCS-2","UCS-2BE","UCS-2LE","UCS-4","UCS-4BE","UCS-4LE","UTF-16","UTF-16BE","UTF-16LE","UTF-32","UTF-32BE","UTF-32LE","UTF-7","C99","JAVA","UCS-2-INTERNAL","UCS-4-INTERNAL","CP437","CP737","CP775","CP852","CP853","CP855","CP857","CP858","CP860","CP861","CP863","CP865","CP869","CP1125","CP864","EUC-JISX0213","Shift_JISX0213","ISO-2022-JP-3","TDS565","RISCOS-LATIN1");

	$dir=opendir('test');
	while($file=readdir($dir)){
		if($file !== '.' && $file !== '..'){
			foreach($encoding as $v){
				if(iconv($v, 'utf-8', $file) === $testString){
					array_push($out, $v);
					array_push($out, iconv($v, 'utf-8', $file));
					break;
				}
			}
		}
		
	}
	return $out;
}




/*testString - put file with the same name as $testString in the same dir as this script*/
/*you can change testString if you want*/
$filename='zażółć gęślą jaźń.txt';
$charset = array();
$charset = checkCharset($filename);

	echo '<h2 lang="en">your filename encoding is '.$charset[1].'</h2>';
	echo "<p lang=\"en\">testString: $charset[0]</p>";
	echo "<p lang=\"en\">file name: ".$charset[2]."</p>";



/*if you have found your encoding
you have to iconv() your filename to 
encoding you want. Eg.:
$encodedFileName = iconv($myEncoding, 'utf-8', $fileName);
*/
?>

</body>
</html>